
/******************************************************************************
 				GfxSettingsWnd.c 
 Copyright  2008  Birger N. Andreasen 
 Please send any bugreports, comments and other issues to:
 E-Mail = bna@post10.tele.dk
 Homepage with other ROTT stuff = http://home14.inet.tele.dk/Bna-Info
/******************************************************************************/

 


//----------------------------------------------------------------------
// Windows Includes...
//----------------------------------------------------------------------
 
#include <windows.h>
#include "WinRott.h"
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include "..\\resource.h" 
#include "develop.h"
#include <windowsx.h>

extern BOOL  bUseOldSkys ;
extern BOOL  bIntPolOldSkys ;

extern BOOL  bAbovemaskwall ;
extern BOOL  bAbovewall ;
extern BOOL  bDoors ;
extern BOOL  bElevators  ;
extern BOOL  bExits  ;
extern BOOL  bFloor_Ceilings  ;
extern BOOL  bGuns  ;
extern BOOL  bHswicthes  ;
extern BOOL  bMasked  ;
extern BOOL  bMish  ;
extern BOOL  bShapes  ;
extern BOOL  bSides  ;
extern BOOL  bWalls  ;
extern BOOL  bUseExtPrecache;
extern BOOL  bUseExtWallSFX;
extern BOOL  bUseExtSFX;
extern int RunFullscreen;

extern int compat;
extern int gltexmode;	
extern int glsharpentex;

extern char g_alpha_totalonoff;//bna++156
extern double g_explo_alpha;//bna++148
extern double g_organ_alpha;//bna++148
extern double g_firej_alpha;//bna++148
extern double g_lifei_alpha;//bna++148
extern double g_bullet_alpha;//bna++148

LRESULT CALLBACK GfxSettingsWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void GfxMsg_InitDialog (HWND hWnd);
int GfxGetSetDialogItem(HWND hWnd, int id, char *str, char *defval);
void FillCombo (HWND hWnd,int id, int idcombo,double a);
HBRUSH AdjustStaticBackgroundColors (HWND hwnd, HDC hdc);

extern void DisEnableRottButtons(BOOL bDisEnable);
extern BOOL SetStrInRegdb  (LPSTR Keyval, LPSTR strval, LPSTR defaultval)  ;
extern int GetStrFromRegdb (LPSTR Keyval, LPSTR strval, LPSTR defaultval) ;


COLORREF crGREEN_PROGRESS;
HBRUSH   GREEN_PROGRESS;


// Mesage handler for GfxSettingsWnd box.
LRESULT CALLBACK GfxSettingsWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ix;
	switch (message)
	{			
		case WM_INITDIALOG:
			    GfxMsg_InitDialog (hDlg);
				DisEnableRottButtons(FALSE);
				//--------------------------------------
				crGREEN_PROGRESS = RGB(45,135,29);
				GREEN_PROGRESS   = CreateSolidBrush(crGREEN_PROGRESS);
				return TRUE;

		case WM_CTLCOLORSTATIC:
			for (ix = IDC_STATIC_G1;ix <= IDC_STATIC_G6; ix++){
				if ((HWND)lParam == GetDlgItem(hDlg,ix)) 
					SetTextColor((HDC)wParam,crGREEN_PROGRESS);
			}
			return (LRESULT)(HBRUSH)AdjustStaticBackgroundColors ((HWND)lParam,(HDC)wParam);
		case WM_COMMAND:
			if (LOWORD(wParam) == ID_ALPHA_TOTALONOFF) 
			{
				if (g_alpha_totalonoff == 0){
					g_alpha_totalonoff = 1;
					SetStrInRegdb ("ID_ALPHA_TOTALONOFF","1","1"); 
					//SendDlgItemMessage(hDlg,ID_ALPHA_TOTALONOFF,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_EXP),1);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_EXP),1);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_EXP),1);	

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_FJETS),1);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_FIREJ),1);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_FIREJ),1);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_LIFE),1);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_LIFE),1);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LIFEIT),1);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_ORGANS),1);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_ORGAN),1);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ORGANS),1);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_BTH),1);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_BTH),1);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BULHOL),1);


				}else{
					g_alpha_totalonoff = 0;
					SetStrInRegdb ("ID_ALPHA_TOTALONOFF","0","1"); 
					//SendDlgItemMessage(hDlg,ID_ALPHA_TOTALONOFF,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_EXP),0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_EXP),0);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_EXP),0);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_FJETS),0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_FIREJ),0);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_FIREJ),0);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_LIFE),0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_LIFE),0);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LIFEIT),0);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_ORGANS),0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_ORGAN),0);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ORGANS),0);

					EnableWindow(GetDlgItem(hDlg,ID_ALPHA_BTH),0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_BTH),0);
					EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BULHOL),0);
				}
				break;
			}


			if (LOWORD(wParam) == ID_ALPHA_EXP) 
			{

				if (g_explo_alpha >= 0){
					SendDlgItemMessage(hDlg,ID_ALPHA_EXP,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_EXP),0);
				}else{
					SendDlgItemMessage(hDlg,ID_ALPHA_EXP,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_EXP),1);
				}
				g_explo_alpha *= -1.0;
				break;
			}
			if (LOWORD(wParam) == ID_ALPHA_FJETS) 
			{
				if (g_firej_alpha >= 0){
					SendDlgItemMessage(hDlg,ID_ALPHA_FJETS,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_FIREJ),0);
				}else{
					SendDlgItemMessage(hDlg,ID_ALPHA_FJETS,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_FIREJ),1);
				}
				g_firej_alpha *= -1.0;
				break;
			}
			if (LOWORD(wParam) == ID_ALPHA_LIFE) 
			{

				if (g_lifei_alpha >= 0){
					SendDlgItemMessage(hDlg,ID_ALPHA_LIFE,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_LIFE),0);
				}else{
					SendDlgItemMessage(hDlg,ID_ALPHA_LIFE,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_LIFE),1);
				}
				g_lifei_alpha *= -1.0;
				break;
			}
			if (LOWORD(wParam) == ID_ALPHA_ORGANS) 
			{

				if (g_organ_alpha >= 0){
					SendDlgItemMessage(hDlg,ID_ALPHA_ORGANS,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_ORGAN),0);
				}else{
					SendDlgItemMessage(hDlg,ID_ALPHA_ORGANS,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_ORGAN),1);
				}
				g_organ_alpha *= -1.0;
				break;
			}
			if (LOWORD(wParam) == ID_ALPHA_BTH) 
			{

				if (g_bullet_alpha >= 0){
					SendDlgItemMessage(hDlg,ID_ALPHA_BTH,BM_SETCHECK,0,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_BTH),0);
				}else{
					SendDlgItemMessage(hDlg,ID_ALPHA_BTH,BM_SETCHECK,1,0);
					EnableWindow(GetDlgItem(hDlg,IDC_COMBO_A_BTH),1);
				}
				g_bullet_alpha *= -1.0;
				break;
			}
			if (LOWORD(wParam) == IDOK) 
			{
				char tmp[64] = "";
				char tmp1[64] = "";
				compat = 0; 
				if (IsDlgButtonChecked(hDlg,ID_NO_CATWALK)==1)
					compat = compat ^ 1;
				if (IsDlgButtonChecked(hDlg,ID_NO_MODELS)==1)
					compat = compat ^ 2;
				if (IsDlgButtonChecked(hDlg,ID_OLD_LOOKMODE)==1)
					compat = compat ^ 4;
				if (IsDlgButtonChecked(hDlg,ID_NO_FATBLOCK)==1)
					compat = compat ^ 8;
				if (IsDlgButtonChecked(hDlg,ID_NO_FLOORDEPTH)==1)
					compat = compat ^ 16;
  				sprintf(tmp,"%d",compat);
				SetStrInRegdb ("Compat",tmp,"0"); 

				if (SendDlgItemMessage(hDlg,ID_GL_DEFAULT,BM_GETCHECK,1,0)==1)
					gltexmode = -1;
				if (SendDlgItemMessage(hDlg,ID_GL_NEAREST,BM_GETCHECK,1,0)==1)
					gltexmode = 0;
				if (SendDlgItemMessage(hDlg,ID_GL_LINEAR,BM_GETCHECK,1,0)==1)
					gltexmode = 1;
				if (SendDlgItemMessage(hDlg,ID_GL_NEAREST_MIPMAP_NEAREST,BM_GETCHECK,1,0)==1)
					gltexmode = 2;
				if (SendDlgItemMessage(hDlg,ID_GL_NEAREST_MIPMAP_LINEAR,BM_GETCHECK,1,0)==1)
					gltexmode = 3;
				if (SendDlgItemMessage(hDlg,ID_GL_LINEAR_MIPMAP_NEAREST,BM_GETCHECK,1,0)==1)
					gltexmode = 4;
				if (SendDlgItemMessage(hDlg,ID_GL_LINEAR_MIPMAP_LINEAR,BM_GETCHECK,1,0)==1)
					gltexmode = 5;
  				sprintf(tmp,"%d",gltexmode);
				SetStrInRegdb ("TexMode",tmp,"2"); 


				if (IsDlgButtonChecked(hDlg,IDM_FULLSCREEN)==1){
					SetStrInRegdb ("FullScreen","1","0"); 
					RunFullscreen = 1;
				}else{
					SetStrInRegdb ("FullScreen","0","0"); 
					RunFullscreen = 0;
				}

				if (IsDlgButtonChecked(hDlg,ID_SETTINGS_USEEXTENDEDPRECACHE)==1){
					SetStrInRegdb ("UseExtPrecache","1","0"); 
					bUseExtPrecache = 1;
				}else{
					SetStrInRegdb ("UseExtPrecache","0","0"); 
					bUseExtPrecache = 0;
				}

				if (IsDlgButtonChecked(hDlg,ID_SETTINGS_USESFX)==1){
					SetStrInRegdb ("UseExtWallSFX","1","0"); 
					bUseExtWallSFX = 1;
				}else{
					SetStrInRegdb ("UseExtWallSFX","0","0"); 
					bUseExtWallSFX = 0;
				}


				if (IsDlgButtonChecked(hDlg,ID_SHARPEN_GFX)==1){
					SetStrInRegdb ("glsharpentex","1","0"); 
					glsharpentex = 1;
				}else{
					SetStrInRegdb ("glsharpentex","0","0"); 
					glsharpentex = 0;
				}


				if (IsDlgButtonChecked(hDlg,ID_OLD_SKYS)==1){
					SetStrInRegdb ("UseOldSkys","1","0"); 
					bUseOldSkys = 1;
				}else{
					SetStrInRegdb ("UseOldSkys","0","0"); 
					bUseOldSkys = 0;
				}

				if (IsDlgButtonChecked(hDlg,ID_OLD_INTPOL_SKYS)==1){
					SetStrInRegdb ("IntPolOldSkys","1","0"); 
					bIntPolOldSkys = 1;
				}else{
					SetStrInRegdb ("IntPolOldSkys","0","0"); 
					bIntPolOldSkys = 0;
				}

				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_ABOVEMASKWALL)==1){
					SetStrInRegdb ("Abovemaskwall","1","0"); 
					bAbovemaskwall = 1;
				}else{
					SetStrInRegdb ("Abovemaskwall","0","0"); 
					bAbovemaskwall = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_ABOVEWALL)==1){
					SetStrInRegdb ("Abovewall","1","0"); 
					bAbovewall = 1;
				}else{
					SetStrInRegdb ("Abovewall","0","0"); 
					bAbovewall = 0;
				}	
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_DOORS)==1){
					SetStrInRegdb ("Doors","1","0"); 
					bDoors = 1;
				}else{
					SetStrInRegdb ("Doors","0","0"); 
					bDoors = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_ELEVATORS)==1){
					SetStrInRegdb ("Elevators","1","0"); 
					bElevators = 1;
				}else{
					SetStrInRegdb ("Elevators","0","0"); 
					bElevators = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_EXITS)==1){
					SetStrInRegdb ("Exits","1","0"); 
					bExits = 1;
				}else{
					SetStrInRegdb ("Exits","0","0"); 
					bExits = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_FLOOR)==1){
					SetStrInRegdb ("Floor_Ceilings","1","0"); 
					bFloor_Ceilings = 1;
				}else{
					SetStrInRegdb ("Floor_Ceilings","0","0"); 
					bFloor_Ceilings = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_GUNS)==1){
					SetStrInRegdb ("Guns","1","0"); 
					bGuns = 1;
				}else{
					SetStrInRegdb ("Guns","0","0"); 
					bGuns = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_HSWICTHES)==1){
					SetStrInRegdb ("Hswicthes","1","0"); 
					bHswicthes = 1;
				}else{
					SetStrInRegdb ("Hswicthes","0","0"); 
					bHswicthes = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_MASKED)==1){
					SetStrInRegdb ("Masked","1","0"); 
					bMasked = 1;
				}else{
					SetStrInRegdb ("Masked","0","0"); 
					bMasked = 0;
				}	

				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_MISH)==1){
					SetStrInRegdb ("Mish","1","0"); 
					bMish = 1;
				}else{
					SetStrInRegdb ("Mish","0","0"); 
					bMish = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_SHAPES)==1){
					SetStrInRegdb ("Shapes","1","0"); 
					bShapes = 1;
				}else{
					SetStrInRegdb ("Shapes","0","0"); 
					bShapes = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_SIDES)==1){
					SetStrInRegdb ("Sides","1","0"); 
					bSides = 1;
				}else{
					SetStrInRegdb ("Sides","0","0"); 
					bSides = 0;
				}
				if (IsDlgButtonChecked(hDlg,ID_SOFTENGFX_WALLS)==1){
					SetStrInRegdb ("Walls","1","0"); 
					bWalls = 1;
				}else{
					SetStrInRegdb ("Walls","0","0"); 
					bWalls = 0;
				}

				//hereunder all the new alpha things bna++148
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_TOTALONOFF)==1){
					g_alpha_totalonoff = 1;
					SetStrInRegdb ("ALPHA_TOTALONOFF",tmp,"1"); 
				}else{
					g_alpha_totalonoff = 0;
					SetStrInRegdb ("ALPHA_TOTALONOFF",tmp,"0"); 
				}


				//if alpha is below 0 its not used
				GetWindowText(GetDlgItem(hDlg,IDC_COMBO_A_EXP),tmp,sizeof(tmp));
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_EXP)==1){
					g_explo_alpha = atof(tmp);
					SetStrInRegdb ("ALPHA_EXP",tmp,"1"); 
				}else{
					lstrcpy(tmp1,"-");
					lstrcat(tmp1,tmp);
					SetStrInRegdb ("ALPHA_EXP",tmp1,"1.0");

				}
				GetWindowText(GetDlgItem(hDlg,IDC_COMBO_A_ORGAN),tmp,sizeof(tmp));
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_ORGANS)==1){
					g_organ_alpha = atof(tmp);
					SetStrInRegdb ("ALPHA_ORGANS",tmp,"1"); 
				}else{
					lstrcpy(tmp1,"-");
					lstrcat(tmp1,tmp);
					SetStrInRegdb ("ALPHA_ORGANS",tmp1,"1.0"); 
				}
					
				GetWindowText(GetDlgItem(hDlg,IDC_COMBO_A_FIREJ),tmp,sizeof(tmp));
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_FJETS)==1){
					g_firej_alpha = atof(tmp);
					SetStrInRegdb ("ALPHA_FJETS",tmp,"1"); 
				}else{
					lstrcpy(tmp1,"-");
					lstrcat(tmp1,tmp);
					SetStrInRegdb ("ALPHA_FJETS",tmp1,"1.0"); 
				}

				GetWindowText(GetDlgItem(hDlg,IDC_COMBO_A_LIFE),tmp,sizeof(tmp));
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_LIFE)==1){
					g_lifei_alpha = atof(tmp);
					SetStrInRegdb ("ALPHA_LIFE",tmp,"1"); 
				}else{
					lstrcpy(tmp1,"-");
					lstrcat(tmp1,tmp);
					SetStrInRegdb ("ALPHA_LIFE",tmp1,"1.0"); 
				}
					
				GetWindowText(GetDlgItem(hDlg,IDC_COMBO_A_BTH),tmp,sizeof(tmp));
				if (IsDlgButtonChecked(hDlg,ID_ALPHA_BTH)==1){
					g_bullet_alpha = atof(tmp);
					SetStrInRegdb ("ALPHA_BTH",tmp,"1"); 
				}else{
					lstrcpy(tmp1,"-");
					lstrcat(tmp1,tmp);
					SetStrInRegdb ("ALPHA_BTH",tmp1,"1.0"); 
				}

				DisEnableRottButtons(TRUE);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			if (LOWORD(wParam) == IDCANCEL) 
			{
				DisEnableRottButtons(TRUE);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
//bAbovemaskwall = FALSE;
//	SetStrInRegdb ("Abovemaskwall","0","0");


int GfxGetSetDialogItem(HWND hWnd, int id, char *str, char *defval)
{
	char tmp[512] = "";
	int retval = -1;

	lstrcpy(tmp,defval);//default
	if (GetStrFromRegdb ((LPSTR)str,(LPSTR)&tmp,defval) != -1){
		retval = atoi(tmp);
		if (retval == TRUE){
			SendDlgItemMessage(hWnd,id,BM_SETCHECK,1,0);
		}else{
			SendDlgItemMessage(hWnd,id,BM_SETCHECK,0,0);
		}
	}else return 0;

	return retval;
}



void GfxMsg_InitDialog (HWND hWnd)
{
	char tmp[256];
//	int i;

	RunFullscreen = GfxGetSetDialogItem(hWnd,IDM_FULLSCREEN,"FullScreen","1");
	bUseExtWallSFX = GfxGetSetDialogItem(hWnd,ID_SETTINGS_USESFX,"UseExtWallSFX","0");
	bUseExtPrecache = GfxGetSetDialogItem(hWnd,ID_SETTINGS_USEEXTENDEDPRECACHE,"UseExtPrecache","0");

	glsharpentex = GfxGetSetDialogItem(hWnd,ID_SHARPEN_GFX,"glsharpentex","0");

	bUseOldSkys = GfxGetSetDialogItem(hWnd,ID_OLD_SKYS,"UseOldSkys","1");
	bIntPolOldSkys = GfxGetSetDialogItem(hWnd,ID_OLD_INTPOL_SKYS,"IntPolOldSkys","1");

	bAbovemaskwall = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_ABOVEMASKWALL,"Abovemaskwall","0");
	bAbovewall = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_ABOVEWALL,"Abovewall","0");
	bDoors = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_DOORS,"Doors","0");
	bElevators = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_ELEVATORS,"Elevators","0");
	bExits = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_EXITS,"Exits","0");
	bFloor_Ceilings = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_FLOOR,"Floor_Ceilings","0");
	bGuns = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_GUNS,"Guns","0");
	bHswicthes = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_HSWICTHES,"Hswicthes","0");
	bMasked = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_MASKED,"Masked","0");
	bMish = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_MISH,"Mish","0");
	bShapes = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_SHAPES,"Shapes","0");
	bSides = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_SIDES,"Sides","0");
	bWalls = GfxGetSetDialogItem(hWnd,ID_SOFTENGFX_WALLS,"Walls","0");

	g_alpha_totalonoff = GfxGetSetDialogItem(hWnd,ID_ALPHA_TOTALONOFF,"ID_ALPHA_TOTALONOFF","1");

	lstrcpy(tmp,"0.6");//default
	if (GetStrFromRegdb ((LPSTR)"ALPHA_EXP",(LPSTR)&tmp,(LPSTR)"0.6") != -1)
		g_explo_alpha = atof(tmp);
	else
		g_explo_alpha = 0.6;
	FillCombo (hWnd,ID_ALPHA_EXP,IDC_COMBO_A_EXP,g_explo_alpha);
	

	lstrcpy(tmp,"0.6");//default
	if (GetStrFromRegdb ((LPSTR)"ALPHA_FJETS",(LPSTR)&tmp,(LPSTR)"0.6") != -1)
		g_firej_alpha = atof(tmp);
	else
		g_firej_alpha = 0.6;
	FillCombo (hWnd,ID_ALPHA_FJETS,IDC_COMBO_A_FIREJ,g_firej_alpha);

	lstrcpy(tmp,"0.8");//default
	if (GetStrFromRegdb ((LPSTR)"ALPHA_LIFE",(LPSTR)&tmp,(LPSTR)"0.8") != -1)
		g_lifei_alpha = atof(tmp);
	else
		g_lifei_alpha = 0.8;
	FillCombo (hWnd,ID_ALPHA_LIFE,IDC_COMBO_A_LIFE,g_lifei_alpha);

	lstrcpy(tmp,"0.6");//default
	if (GetStrFromRegdb ((LPSTR)"ALPHA_ORGANS",(LPSTR)&tmp,(LPSTR)"0.6") != -1)
		g_organ_alpha = atof(tmp);
	else
		g_organ_alpha = 0.6;
	FillCombo (hWnd,ID_ALPHA_ORGANS,IDC_COMBO_A_ORGAN,g_organ_alpha);


	lstrcpy(tmp,"0.8");//default
	if (GetStrFromRegdb ((LPSTR)"ALPHA_BTH",(LPSTR)&tmp,(LPSTR)"0.8") != -1)
		g_bullet_alpha = atof(tmp);
	else
		g_bullet_alpha = 0.6;
	FillCombo (hWnd,ID_ALPHA_BTH,IDC_COMBO_A_BTH,g_bullet_alpha);

	lstrcpy(tmp,"0");//default
	if (GetStrFromRegdb ((LPSTR)"Compat",(LPSTR)&tmp,(LPSTR)"0") != -1){
		compat = atoi(tmp);
		if (compat & 1)
			SendDlgItemMessage(hWnd,ID_NO_CATWALK,BM_SETCHECK,1,0);
		if (compat & 2)
			SendDlgItemMessage(hWnd,ID_NO_MODELS,BM_SETCHECK,1,0);
		if (compat & 4)
			SendDlgItemMessage(hWnd,ID_OLD_LOOKMODE,BM_SETCHECK,1,0);
 		if (compat & 8)
			SendDlgItemMessage(hWnd,ID_NO_FATBLOCK,BM_SETCHECK,1,0);
		if (compat & 16)
			SendDlgItemMessage(hWnd,ID_NO_FLOORDEPTH,BM_SETCHECK,1,0);
                                                        
	}
	
	lstrcpy(tmp,"-1");//default
	if (GetStrFromRegdb ((LPSTR)"TexMode",(LPSTR)&tmp,(LPSTR)"-1") != -1){
		gltexmode = atoi(tmp);
		if (gltexmode == -1)
			SendDlgItemMessage(hWnd,ID_GL_DEFAULT,BM_SETCHECK,1,0);
		if (gltexmode == 0)
			SendDlgItemMessage(hWnd,ID_GL_NEAREST,BM_SETCHECK,1,0);
 		if (gltexmode == 1)
			SendDlgItemMessage(hWnd,ID_GL_LINEAR,BM_SETCHECK,1,0);
 		if (gltexmode == 2)
			SendDlgItemMessage(hWnd,ID_GL_NEAREST_MIPMAP_NEAREST,BM_SETCHECK,1,0);
		if (gltexmode == 3)
			SendDlgItemMessage(hWnd,ID_GL_NEAREST_MIPMAP_LINEAR,BM_SETCHECK,1,0);
		if (gltexmode == 4)
			SendDlgItemMessage(hWnd,ID_GL_LINEAR_MIPMAP_NEAREST,BM_SETCHECK,1,0);
		if (gltexmode == 5)
			SendDlgItemMessage(hWnd,ID_GL_LINEAR_MIPMAP_LINEAR,BM_SETCHECK,1,0);
                                                                                                
	}
	if (g_alpha_totalonoff == 0){
		EnableWindow(GetDlgItem(hWnd,ID_ALPHA_EXP),0);
		EnableWindow(GetDlgItem(hWnd,IDC_COMBO_A_EXP),0);
		EnableWindow(GetDlgItem(hWnd,IDC_STATIC_EXP),0);
		EnableWindow(GetDlgItem(hWnd,ID_ALPHA_FJETS),0);
		EnableWindow(GetDlgItem(hWnd,IDC_COMBO_A_FIREJ),0);
		EnableWindow(GetDlgItem(hWnd,IDC_STATIC_FIREJ),0);
		EnableWindow(GetDlgItem(hWnd,ID_ALPHA_LIFE),0);
		EnableWindow(GetDlgItem(hWnd,IDC_COMBO_A_LIFE),0);
		EnableWindow(GetDlgItem(hWnd,IDC_STATIC_LIFEIT),0);
		EnableWindow(GetDlgItem(hWnd,ID_ALPHA_ORGANS),0);
		EnableWindow(GetDlgItem(hWnd,IDC_COMBO_A_ORGAN),0);
		EnableWindow(GetDlgItem(hWnd,IDC_STATIC_ORGANS),0);
		EnableWindow(GetDlgItem(hWnd,ID_ALPHA_BTH),0);
		EnableWindow(GetDlgItem(hWnd,IDC_COMBO_A_BTH),0);
		EnableWindow(GetDlgItem(hWnd,IDC_STATIC_BULHOL),0);
	}
}


void FillCombo (HWND hWnd,int id, int idcombo,double a)
{
	char tmp[12];
	int i;


	for (i=0;i<10;i++){
		sprintf (tmp,"0.%d",i); 
		SendDlgItemMessage(hWnd, idcombo, CB_ADDSTRING, (WPARAM) 0, (LPARAM) tmp);
	} 

	SendDlgItemMessage(hWnd, idcombo, CB_ADDSTRING, (WPARAM) 0, (LPARAM) "1.0");
	SendDlgItemMessage(hWnd, idcombo, CB_SETCURSEL, (WPARAM) (int)abs((int)(a*10)), (LPARAM) 0);

	if (a < 0){
		SendDlgItemMessage(hWnd,id,BM_SETCHECK,0,0); 
		EnableWindow(GetDlgItem(hWnd,idcombo),0);
	}else{ 
		SendDlgItemMessage(hWnd,id,BM_SETCHECK,1,0);
		EnableWindow(GetDlgItem(hWnd,idcombo),1);
	}

}

HBRUSH AdjustStaticBackgroundColors (HWND hwnd, HDC hdc)
{
	//here we ad just the default background color
	//by testing the pixel color 2 pixels
	//to the left and 2 pixel down and
	//use that colorref to bg color
	//used mostly in WM_CTLCOLORSTATIC
	COLORREF cr;
	RECT rc;
	HDC desktop = GetDC(NULL);
	GetWindowRect((HWND)hwnd, &rc);
	cr = GetPixel((HDC)desktop,rc.left-2,rc.top+2);			
	SetBkMode((HDC)hdc,TRANSPARENT );
	ReleaseDC(NULL,desktop);
	return (HBRUSH)CreateSolidBrush(cr);
}